package imaputils

import (
	"git.lattuga.net/blallo/papero/config"
	"github.com/emersion/go-imap"
)

func ListMailboxes(conf *config.AccountData, debug bool) ([]*imap.MailboxInfo, error) {
	var mailboxes []*imap.MailboxInfo
	conn := NewConnection(conf)

	err := conn.Start(debug)
	if err != nil {
		return mailboxes, err
	}
	defer conn.Close()

	mboxChan := make(chan *imap.MailboxInfo, 10)
	done := make(chan error, 1)
	go func() {
		done <- conn.client.List("", "*", mboxChan)
	}()

	for m := range mboxChan {
		mailboxes = append(mailboxes, m)
	}

	if err := <-done; err != nil {
		return mailboxes, err
	}

	return mailboxes, nil
}
